; TMTL 3.10
; last updated 02.Nov.2000

__VERSION__     equ '3.10'

.386
locals  @@

include d32headr.ash


data    segment dword use32 public 'bss'
; global variables

        module_name dd ?                ; executable file path/name
        module_size dd ?                ; executable file size
                                        ; (for DOS32 API emulation)

        dos32header tdos32header <>     ; DOS32 exe file header
                                        ; also used as meminfo struc
                                        ; for int 31h

        file_handle dd ?                ; exe file handle for i/o
        io_buf_addr dd ?                ; 8k i/o buffer linear address
        io_buf_seg dw ?                 ; 8k i/o buffer realmode segment
        env_offset dd ?                 ; environment linear address
        psp_offset dd ?                 ; psp linear address


        old_int31 dp ?                  ; original int 31h vector
        old_int21 dp ?                  ; original int 21h vector
        save_ds dw ?                    ; data selector

        mem_block_stack dd 128 dup(?)   ; stack for memory blocks' handles
        mem_block_sp db ?               ; stack pointer for memory block stack

        mem_size dd ?                   ; memavail (for dos32emu)

        buffer_position dd ?            ; buffer position and size
        buffer_size dd ?                ; used in bufinput procedures

data    ends

code    segment byte public use32 'code'
assume  cs:code, ds:data

;===== Main ==================================================================
start:
        jmp     short main
db      'WATCOM'                        ; to make DOS4G happy
main:
        sti
        cld

        mov     ax, data                ; required by CauseWay
        mov     ds, ax

                                        ; initialize DOS32 API emulator
        mov     save_ds, ds             ; save data segment
        mov     bx, es                  ; get psp address
        mov     ax, 6
        int     31h
        mov     word ptr psp_offset, dx
        mov     word ptr psp_offset+2, cx
        mov     ebx, psp_offset
        mov     bx, [ebx+2Ch]           ; get environment address
        int     31h
        jc      _get_envaddr_err
        mov     word ptr env_offset, dx
        mov     word ptr env_offset+2, cx
        mov     es, save_ds             ; es = ds is TMT RTL requirement
        mov     mem_block_sp, 0
        mov     ax, 100h                ; get IO buffer in DOS memory
        mov     bx, 512
        int     31h
        jc      _get_dosmem_err
        mov     io_buf_seg, ax
        movzx   eax, ax
        shl     eax, 4
        mov     io_buf_addr, eax
        mov     ax, 204h                ; get int 31h vector
        mov     bl, 31h
        int     31h
        mov     dword ptr old_int31, edx
        mov     word ptr old_int31+4, cx
        mov     bl, 21h                 ; get int 21h vector
        int     31h
        mov     dword ptr old_int21, edx
        mov     word ptr old_int21+4, cx
        mov     ax, 205h                ; set new int 21h vector
        mov     cx, cs
        lea     edx, hook21
        int     31h
        mov     bl, 31h
        lea     edx, hook31             ; set new int 31h vector
        int     31h
                                        ; get TMTLOAD and argv[0]
        mov     edi, env_offset
        mov     ecx, 0FFFFh
        xor     ebx, ebx
        mov     al, bl
_next_var:
        test    ebx, ebx
        jnz     _skip                   ; already found
        cmp     dword ptr [edi], 'LTMT'
        jne     _skip
        cmp     dword ptr [edi+4], '=DAO'
        jne     _skip
        lea     ebx, [edi+8]            ; address of module name
_skip:
        cmp     byte ptr [edi], 0
        je      _env_end
        repnz   scasb
        jmp     short _next_var
_env_end:
        not     cx
        add     ecx, env_offset
        add     ecx, 3

        mov     esi, psp_offset
        cmp     byte ptr [esi+4], 33h   ; check for TMTLSTUB flag
        je      _not_bound
        mov     module_name, ecx
        jmp     short load_and_execute
_not_bound:
        test    ebx, ebx
        jz      _bad_env_err
        mov     module_name, ebx

;===== flat DOS32 executable loader ==========================================
load_and_execute:
        mov     ebp, esp                ; allocate local variables
        sub     esp, 16

        stub_size equ [ebp-16]
        code_pool equ [ebp-12]
        r_buf   equ [ebp-8]
        r_handle equ [ebp-4]

        mov     dword ptr stub_size, 0
        mov     ax, 3D00h               ; open module (r/o mode)
        mov     edx, module_name
        int     21h
        jc      _open_file_err
        movzx   ebx, ax                 ; get file handle
        mov     file_handle, ebx
_stub_loop:                             ; skip stub and calculate stub size
        mov     word ptr dos32header, 0
        mov     ah, 3Fh                 ; read 6 bytes
        lea     edx, dos32header
        mov     ecx, 6
        int     21h
        jc      _disk_read_err
        cmp     word ptr dos32header, 'ZM'
        je      _mz_stub
        cmp     word ptr dos32header, 'MZ'
        je      _mz_stub
        cmp     word ptr dos32header, 'EL'
        je      _le_stub
        cmp     dos32header.signature, 'madA'
        je      _d32_body
        jmp     _invalid_module_format_err
_mz_stub:                               ; MZ-style stub
        cmp     word ptr dos32header+2, 0; if page-aligned
        je      _page_aligned           ; then use full number of pages
        dec     word ptr dos32header+4  ; else dec number of pages
_page_aligned:
        movzx   edx, word ptr dos32header+4; number of pages
        shl     edx, 9                  ; multiply by 512
        movzx   ecx, word ptr dos32header+2; bytes on last page
        add     edx, ecx
        add     stub_size, edx          ; increment stub size
        sub     edx, 6                  ; minus current position
        mov     ecx, edx
        shr     ecx, 16                 ; cx:dx = offset to next byte
                                        ; after stub
        mov     ax, 4201h               ; seek from current position
        int     21h
        jnc     _stub_loop              ; process next stub (if any)
        jmp     _seek_err
_le_stub:                               ; LE-style stub (TMTL image)
        xor     cx, cx
        mov     dx, 152-6               ; "debug info" field offset
        mov     ax, 4201h
        int     21h
        jc      _seek_err
        mov     ah, 3Fh                 ; read length of LE stub
        lea     edx, dos32header
        mov     ecx, 4
        int     21h
        jc      _disk_read_err
        mov     edx, dword ptr dos32header
        add     stub_size, edx          ; add LE size to overall stub size
        sub     edx, 156                ; minus current position
        mov     ecx, edx
        shr     ecx, 16
        mov     ax, 4201h
        int     21h                     ; seek to next stub (if any)
        jnc     _stub_loop
        jmp     _seek_err
_d32_body:                              ; actual DOS32 image
        mov     ah, 3Fh
        lea     edx, dos32header+6      ; first six bytes alredy read
        mov     ecx, 38                 ; 38+6 = 44 = DOS32 EXE header size
        int     21h
        jc      _disk_read_err
        cmp     eax, 38                 ; if less then 38 bytes, then
                                        ; somethig's wrong
        jne     _unexpected_eof_err
        cmp     dos32header.image_offset, 44; must be >=44
        jb      _invalid_module_format_err
        mov     eax, stub_size          ; calculate exe size for dos32emu
        add     eax, dos32header.stripped_length
        add     eax, dos32header.tmt_reloc_table_size
        mov     module_size, eax

        test    dos32header.flags, show_banner
        jz      _no_banner
        lea     edx, banner
        mov     ah, 9
        int     21h
_no_banner:
        mov     ax, 501h                ; allocate code pool
        mov     cx, word ptr dos32header.memory_required
        mov     bx, word ptr dos32header.memory_required+2
                                        ; bx:cx = memory amount
        int     31h
        jc      _dpmi_mem_err
        mov     word ptr code_pool, cx
        mov     word ptr code_pool+2, bx; codepool linear address

        mov     ax, 501h                ; allocate ring/reloc buffer
        mov     ecx, dos32header.tmt_reloc_table_size
        add     ecx, 8192               ; 8k for ring buffer
        mov     bx, word ptr dos32header.tmt_reloc_table_size+2
        int     31h
        jc      _dpmi_mem_err
        mov     word ptr r_buf, cx      ; bx:cx - address
        mov     word ptr r_buf+2, bx
        mov     word ptr r_handle, di   ; si:di - handle
        mov     word ptr r_handle+2, si

        mov     ebx, file_handle        ; restore file handle
                                        ; seek to image
        mov     edx, stub_size
        add     edx, dos32header.image_offset
        mov     ecx, edx
        shr     ecx, 16
        mov     ax, 4200h
        int     21h
        jc      _seek_err
        test    dos32header.flags, image_compressed; see if image compressed
        jnz     _unpack_image
                                        ; read image to codepool
        mov     ah, 3Fh
        mov     edx, code_pool
        mov     ecx, dos32header.image_length
        int     21h
        jc      _disk_read_err
        cmp     eax, dos32header.image_length
        je      _load_reloc_table
        jmp     _unexpected_eof_err
_unpack_image:                          ; unpack compressed image
        mov     eax, dos32header.image_length; compressed length
        mov     edi, code_pool          ; destination buffer
        mov     esi, r_buf              ; ring buffer
        call    lzs_decode
        mov     dos32header.image_length, eax; decoded data size
        mov     ebx, file_handle        ; restore file handle
_load_reloc_table:
                                        ; seek to relocs
        cmp     dos32header.tmt_reloc_table_size, 0
        je      _close_file
        mov     edx, stub_size
        add     edx, dos32header.stripped_length
        mov     ecx, edx
        shr     ecx, 16
        mov     ax, 4200h
        int     21h
        jc      _seek_err
        mov     ah, 3Fh
        mov     edx, r_buf
        add     edx, 8192
        test    dos32header.flags, reloc_compressed
        jnz     _unpack_relocs
                                        ; load fixup table
        mov     ecx, dos32header.tmt_reloc_table_size
        int     21h
        jc      _disk_read_err
        cmp     eax, dos32header.tmt_reloc_table_size
        je      _apply_fixups
        jmp     _unexpected_eof_err
_unpack_relocs:
        mov     ecx, 4                  ; read original fixup table size
        int     21h
        jc      _disk_read_err
        mov     ebx, r_buf
        mov     ecx, [ebx+8192]
        add     ecx, 8192
        mov     ebx, ecx
        shr     ebx, 16                 ; bx:cx = new buffer size
        mov     di, word ptr r_handle
        mov     si, word ptr r_handle+2
        mov     ax, 503h
        int     31h                     ; resize memory block
        jc      _dpmi_mem_err
        mov     word ptr r_buf, cx      ; new address
        mov     word ptr r_buf+2, bx
        mov     word ptr r_handle, di   ; new handle
        mov     word ptr r_handle+2, si
        mov     eax, dos32header.tmt_reloc_table_size; unpack fixups
        mov     edi, r_buf
        mov     esi, edi
        add     edi, 8192               ; reloc table is at
                                        ; offset 8k in @@r_buf
        mov     ebx, file_handle
        call    lzs_decode
        mov     dos32header.tmt_reloc_table_size, eax; decoded data length
        mov     ebx, file_handle        ; restore file handle
_apply_fixups:
                                        ; apply fixups
        mov     edi, code_pool
        mov     esi, r_buf
        add     esi, 8192
        mov     ecx, dos32header.tmt_reloc_table_size
        shr     ecx, 2
_next_fixup:
        lodsd
        add     [edi+eax-4], edi
        loop    _next_fixup

                                        ; free fixup table memory block
        mov     ax, 502h
        mov     di, word ptr r_handle
        mov     si, word ptr r_handle+2
        int     31h

_close_file:
                                        ; close program file
        mov     ah, 3Eh
        int     21h

        mov     ecx, dos32header.memory_required
        sub     ecx, dos32header._esp   ; ecx = global uninitialized data size
        mov     eax, code_pool
        add     dos32header._eip, eax
        add     dos32header._esp, eax

        mov     edi, dos32header._esp   ; bss start
        xor     eax, eax
        mov     ebx, ecx
        shr     ecx, 2
        rep     stosd                   ; zeroinit global data
        mov     ecx, ebx
        and     ecx, 3
        rep     stosb

        xor     ecx, ecx
        xor     edx, edx
        xor     esi, esi
        mov     edi, code_pool          ; required by UPX
        xor     ebp, ebp
        mov     bx, ds
        mov     ss, bx                  ; interrupts should be automagically
                                        ; disabled at this point
        mov     esp, dos32header._esp
        xor     ebx, ebx
                                        ; pass control to loaded code
        jmp     dos32header._eip

;===== abnormal termination ==================================================

_get_dosmem_err:
        lea     ebx, get_dosmem_err
        jmp     short abort
_get_envaddr_err:
        lea     ebx, get_envaddr_err
        jmp     short abort
_bad_env_err:
        lea     ebx, bad_env_err
        jmp     short abort
_open_file_err:
        lea     ebx, open_file_err
        jmp     short abort
_disk_read_err:
        lea     ebx, disk_read_err
        jmp     short abort
_seek_err:
        lea     ebx, seek_err
        jmp     short abort
_invalid_module_format_err:
        lea     ebx, invalid_module_format_err
        jmp     short abort
_dpmi_mem_err:
        lea     ebx, dpmi_mem_err
        jmp     short abort
_unexpected_eof_err:
        lea     ebx, unexpected_eof_err

abort:
; in : ebx point to error message
; out: never
        mov     ah, 9
        lea     edx, err_headr
        int     21h
        mov     edx, ebx
        int     21h
        lea     edx, crlf
        int     21h
        mov     ax, 4CFFh
        int     21h

;===== DOS32 API emulator ====================================================
hook31  proc                            ; new int 31h handler
        cmp     ax, 0EE02h
        je      @@get_addr_info
        cmp     ax, 0EE42h
        je      @@get_mem
        cmp     ax, 0EE40h
        je      @@free_mem
assume  cs:data
        jmp     cs:old_int31
assume  cs:code
@@get_addr_info:
        push    ds
assume  cs:data
        mov     ds, cs:save_ds          ; in ISR DS may not refer to data
assume  cs:code
        xor     ebx, ebx
        mov     edx, module_size
        mov     esi, psp_offset
        mov     edi, env_offset
        mov     ecx, module_name
        mov     ax, io_buf_seg
        pop     ds
        and     byte ptr ss:[esp+8], 0FEh; clear carry flag
        iretd
@@get_mem:
        push    ebx
        push    ecx
        push    esi
        push    edi
        push    ds
assume  cs:data
        mov     ds, cs:save_ds
assume  cs:code
        cmp     mem_block_sp, 128
        jae     @@get_mem_fatal
        mov     mem_size, edx
        mov     cx, dx
        shr     edx, 16
        mov     bx, dx
        mov     ax, 501h
        int     31h
        jc      @@get_mem_err
        mov     dx, bx
        shl     edx, 16
        mov     dx, cx
        mov     eax, mem_size
        movzx   ebx, mem_block_sp
        shl     ebx, 2
        mov     word ptr mem_block_stack+ebx, di
        mov     word ptr mem_block_stack+ebx+2, si
        inc     mem_block_sp
        pop     ds
        pop     edi
        pop     esi
        pop     ecx
        pop     ebx
        and     byte ptr ss:[esp+8], 0FEh
        iretd
@@get_mem_err:
        push    es
assume  cs:data
        mov     es, cs:save_ds
assume  cs:code
        lea     edi, dos32header
        mov     ax, 500h
        int     31h
        pop     es
        jc      @@get_mem_fatal
        mov     cx, word ptr dos32header
        mov     bx, word ptr dos32header+2
        mov     word ptr mem_size, cx
        mov     word ptr mem_size+2, bx
        mov     ax, 501h
        int     31h
        jc      @@get_mem_fatal
        mov     dx, bx
        shl     edx, 16
        mov     dx, cx
        mov     eax, mem_size
        movzx   ebx, mem_block_sp
        shl     ebx, 2
        mov     word ptr mem_block_stack+ebx, di
        mov     word ptr mem_block_stack+ebx+2, si
        inc     mem_block_sp
        jmp     short @@continue
@@get_mem_fatal:
        xor     eax, eax
        xor     edx, edx
@@continue:
        pop     ds
        pop     edi
        pop     esi
        pop     ecx
        pop     ebx
        or      byte ptr ss:[esp+8], 1
        iretd
@@free_mem:
        push    eax
        push    ebx
        push    esi
        push    edi
        push    ds
assume  cs:data
        mov     ds, cs:save_ds
assume  cs:code
        dec     mem_block_sp
        js      @@free_mem_err
        movzx   ebx, mem_block_sp
        shl     ebx, 2
        mov     di, word ptr mem_block_stack+ebx
        mov     si, word ptr mem_block_stack+ebx+2
        mov     ax, 502h
        int     31h
        jc      @@free_mem_err
        pop     ds
        pop     edi
        pop     esi
        pop     ebx
        pop     eax
        and     byte ptr ss:[esp+8], 0EFh
        iretd
@@free_mem_err:
        inc     mem_block_sp
        pop     ds
        pop     edi
        pop     esi
        pop     ebx
        pop     eax
        or      byte ptr ss:[esp+8], 1
        iretd
hook31  endp

;===== int 21h file i/o services patch (required for CauseWay) ===============
hook21  proc                            ; new int 21h handler
        cmp     ah, 3Fh
        je      @@ioproc
        cmp     ah, 40h
        je      @@ioproc
assume  cs:data
        jmp     cs:old_int21
assume  cs:code
@@ioproc:
        push    ecx
        push    edx
        push    esi
        push    edi
        push    eax
        xor     eax, eax
        xor     edi, edi
        mov     esi, ecx
        and     esi, 7FFFh
        push    esi
        shr     ecx, 15
        jecxz   @@io_rest
        mov     esi, ecx
        mov     ecx, 32768
@@rw_block:
        mov     ah, ss:[esp+5]
        pushfd
assume  cs:data
        call    cs:old_int21
assume  cs:code
        jc      @@io_error_
        add     edi, eax
        add     edx, eax
        dec     esi
        jnz     @@rw_block
@@io_rest:
        pop     ecx
        test    ecx, ecx
        jz      @@all_done
        mov     ah, ss:[esp+1]
        pushfd
assume  cs:data
        call    cs:old_int21
assume  cs:code
        jc      @@io_error
        add     edi, eax
@@all_done:
        mov     eax, edi
        jmp     short @@no_error
@@io_error_:
        pop     ecx
@@io_error:
        or      byte ptr ss:[esp+28], 1 ; set carry flag
@@no_error:
        pop     ecx                     ; former ah
        pop     edi
        pop     esi
        pop     edx
        pop     ecx
        iretd
hook21  endp

;===== buffered file input ===================================================
get_byte proc
; in : nothing
; out: ax = next byte from file or -1 on EOF
; modifies ebx,ecx,edx
        mov     eax, buffer_position
        cmp     eax, buffer_size
        jae     @@buffer_end
        add     eax, io_buf_addr
        movzx   eax, byte ptr [eax]
        inc     buffer_position
        jmp     @@exit
@@buffer_end:
        mov     ah, 3Fh
        mov     ebx, file_handle
        mov     ecx, buffer_size
        mov     edx, io_buf_addr
        int     21h
        jc      _disk_read_err
        dec     ax
        js      @@exit                  ; no more bytes to read
        inc     ax
        mov     buffer_size, eax
        movzx   eax, byte ptr [edx]
        mov     buffer_position, 1
@@exit:
        ret
get_byte endp

;===== LZSS decoder ==========================================================
lzs_decode proc
; in:  esi = ring buffer address
;      edi = destination buffer address
;      eax = encoded data length
; out: eax = decoded data length
; modifies eax,ebx,ecx,edx,esi,edi
        push    ebp
        mov     ebp, esp
        sub     esp, 16                 ; make space for local variables

        @@data_counter equ [ebp-16]     ; counter of bytes read
        @@data_size equ [ebp-12]        ; encoded data length
        @@r     equ [ebp-8]             ; index in ring buffer
        @@flags equ [ebp-4]             ; encoding flags

        mov     dword ptr @@data_counter, 0
        mov     @@data_size, eax
        push    edi                     ; preserve destination buffer
                                        ; base address

                                        ; initialize buffered i/o
        mov     buffer_position, 0
        mov     ecx, 8192
        mov     edx, io_buf_addr
        mov     ah, 3Fh
        int     21h
        jc      _disk_read_err
        mov     buffer_size, eax

        mov     ecx, 1020               ; fill ring buffer with spaces
@@next_space:
        dec     ecx
        mov     dword ptr [esi+ecx], 20202020h
        jnz     @@next_space
        mov     dword ptr @@r, 4078     ; index in ring buffer
        mov     word ptr @@flags, 0
@@1:                                    ; main decode loop
        shr     word ptr @@flags, 1
        test    word ptr @@flags, 256
        jnz     @@2
        mov     eax, @@data_counter
        cmp     eax, @@data_size
        je      @@exit
        call    get_byte
        cmp     ax, -1
        je      _unexpected_eof_err
        inc     dword ptr @@data_counter
        or      ax, 0FF00h
        mov     @@flags, ax
@@2:
        test    word ptr @@flags, 1
        jz      @@3
        mov     eax, @@data_counter
        cmp     eax, @@data_size
        je      @@exit
        call    get_byte
        cmp     ax, -1
        je      _unexpected_eof_err
        inc     dword ptr @@data_counter
        mov     ebx, @@r
        mov     [ebx+esi], al
        mov     [edi], al
        inc     edi
        inc     dword ptr @@r
        and     dword ptr @@r, 4095
        jmp     @@1
@@3:
        mov     eax, @@data_counter
        cmp     eax, @@data_size
        je      @@exit
        call    get_byte
        cmp     ax, -1
        je      _unexpected_eof_err
        inc     dword ptr @@data_counter
        push    eax
        mov     eax, @@data_counter
        cmp     eax, @@data_size
        je      @@exit
        call    get_byte
        cmp     ax, -1
        je      _unexpected_eof_err
        inc     dword ptr @@data_counter
        pop     edx
        mov     ebx, eax
        and     ebx, 0F0h
        shl     ebx, 4
        or      edx, ebx
        and     eax, 0Fh
        inc     eax
        inc     eax
        xor     ecx, ecx
@@4:
        mov     ebx, edx
        add     ebx, ecx
        and     ebx, 4095
        push    eax
        mov     al, [esi+ebx]
        mov     ebx, @@r
        mov     [esi+ebx], al
        mov     [edi], al
        inc     edi
        pop     eax
        inc     dword ptr @@r
        and     dword ptr @@r, 4095
        inc     ecx
        cmp     ecx, eax
        jna     @@4
        jmp     @@1
@@exit:
        pop     eax
        sub     edi, eax
        mov     eax, edi                ; eax = decoded data length

        mov     esp, ebp
        pop     ebp
        ret
lzs_decode endp

;===== messages ==============================================================
banner          db 'TMTL loader for TMT-style DOS32 executables', 13, 10
                db 'Version ', __VERSION__, ' build ', ??date, ' ', ??time, 13, 10
                db 'Copyleft (C) 1998-2000 Virtual Research'
crlf            db 13, 10, '$'

err_headr       db 'TMTL error: $'

get_dosmem_err  db 'Cannot allocate DOS memory block$'
get_envaddr_err db 'Cannot get environment address$'
bad_env_err     db 'Bad environment$'
open_file_err   db 'Cannot open program file$'
disk_read_err   db 'Disk read error$'
seek_err        db 'Seek error$'
invalid_module_format_err db 'Invalid executable module format$'
dpmi_mem_err    db 'DPMI memory allocation error$'
unexpected_eof_err db 'Unexpected end of file$'

;===== THE END ===============================================================
code    ends

stacks  segment para stack 'stack'
db      512 dup (?)
stacks  ends

end     start
